package org.dromara.biz.service;

import org.dromara.biz.domain.BizTask;
import org.dromara.biz.domain.bo.BizTaskBo;
import org.dromara.biz.domain.vo.BizTaskVo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 流程数据Service接口
 *
 * @author Blue
 * @date 2025-05-13
 */
public interface IBizTaskService {

    /**
     * 查询流程数据
     *
     * @param id 主键
     * @return 流程数据
     */
    BizTaskVo queryById(Long id);

    /**
     * 分页查询流程数据列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 流程数据分页列表
     */
    TableDataInfo<BizTaskVo> queryPageList(BizTaskBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的流程数据列表
     *
     * @param bo 查询条件
     * @return 流程数据列表
     */
    List<BizTaskVo> queryList(BizTaskBo bo);

    /**
     * 新增流程数据
     *
     * @param bo 流程数据
     * @return 是否新增成功
     */
    Boolean insertByBo(BizTaskBo bo);

    /**
     * 修改流程数据
     *
     * @param bo 流程数据
     * @return 是否修改成功
     */
    Boolean updateByBo(BizTaskBo bo);

    /**
     * 校验并批量删除流程数据信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 保存流程实例表单数据
     * @param instanceId 实例ID
     * @param formData 表单数据
     */
    void saveInstanceFormData(String instanceId, Map<String, Object> formData);

    void updateInstanceFormData(String instanceId, Map<String, Object> formData);

    Boolean deleteByInstanceId(String instanceId);

    BizTask getStatus(String instanceId);
    //  更新流程实例状态
    Boolean updateStatus(String taskNo, String status);
}
